#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/mount.h>

#include "setuproot.h"

char *g_auto_fs_try[] = { "vfat", "iso9660" };
char *g_auto_fs_flags[] = { "umask=7000,quiet", NULL };

void init_filesystem( void ) {
	if (mount("tmpfs", "/tmp", "tmpfs", 0, NULL) != 0) {
		fprintf(stderr, "Unable to mount tmpfs on /tmp: %s\n", strerror(errno));
		exit(1);
	}
	if (mount("proc", "/proc", "proc", 0, NULL) != 0) {
		fprintf(stderr, "Unable to mount proc on /proc: %s\n", strerror(errno));
		exit(1);
	}
	if (mount("sysfs", "/sys", "sysfs", 0, NULL) != 0) {
		fprintf(stderr, "Unable to mount sysfs on /sys: %s\n", strerror(errno));
		exit(1);
	}
	if (mount("tmpfs", ROOT_LOC, "tmpfs", 0, NULL) != 0) {
		fprintf(stderr, "Unable to mount tmpfs on " ROOT_LOC ": %s\n", strerror(errno));
		exit(1);
	}
}

void cleanup_filesystem( void ) {	
	if (umount("/sys") != 0) {
		fprintf(stderr, "Unable to umount /sys: %s\n", strerror(errno));
		exit(1);
	}
	if (umount("/proc") != 0) {
		fprintf(stderr, "Unable to umount /proc: %s\n", strerror(errno));
		exit(1);
	}
	if (umount("/tmp") != 0) {
		fprintf(stderr, "Unable to umount /tmp: %s\n", strerror(errno));
		_exit(1);
	}
}

int auto_fs_mount( char *device, char *path, int flags ) {
	int i;

	for (i=0; i<(sizeof(g_auto_fs_try)/sizeof(g_auto_fs_try[0])); i++) {
		if (mount(device, path, g_auto_fs_try[i], flags, g_auto_fs_flags[i]) 
                == 0)
			return 1;
	}
	return 0;
}
