#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/reboot.h>
#include <sys/wait.h>

static void open_term( void ) {
	int fd;

	fd=open("/dev/console", O_WRONLY | O_NOCTTY | O_NONBLOCK, 0600);
	if (fd != 1) {
		dup2(fd, 1);
	}
	if (fd != 2) {
		dup2(fd, 2);
	}
	if (fd != 1 && fd != 2)
		close(fd);
}

static void disable_reboot( void ) {
	pid_t pid;
	if ((pid=fork()) == 0) {
		reboot(RB_DISABLE_CAD);
		_exit(0);
	}
	waitpid(pid, NULL, 0);
}

void init_startup( void ) {
	/* Ignore signals */
	signal(SIGHUP, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGINT, SIG_IGN);
	signal(SIGTERM, SIG_IGN);
	signal(SIGSTOP, SIG_IGN);

	/* Disable CTRL-ALT-DELETE */
	disable_reboot();

	/* Close normal file handles */
	close(0);
	close(1);
	close(2);

	/* Enforce sane location */
	chdir("/");
	setsid();

	open_term();
}
