#ifndef OVERRIDE_HEADER_H
#define OVERRIDE_HEADER_H

typedef enum {
	OVRDAFT_REG = 0,
	OVRDAFT_DIR,
	OVRDAFT_LINK,
	OVRDAFT_SPECIAL
} OVRDA_FileTypes;

/* Header for all file types */
typedef struct {
	unsigned short type;
	unsigned short uid;
	unsigned short gid;
	unsigned short fn_len;
	/* Filename follows */
} OVRDA_AllHeader;

/* Header for regular files */
typedef struct {
	unsigned long mode;
	unsigned long atime;
	unsigned long mtime;
	unsigned long size;
	/* File data follows */
} OVRDA_FileHeader;

/* Header for directories */
typedef struct {
	unsigned long mode;
} OVRDA_DirHeader;

/* Header for symlinks */
typedef struct {
	unsigned long ln_len;
	/* Symlink contents follow */
} OVRDA_SymlinkHeader;

/* Special file, type is encoded in the mode */
typedef struct {
	unsigned long mode;
	unsigned long dev;
} OVRDA_SpecialHeader;

#endif /* OVERRIDE_HEADER_H */
