CPD_DEPENDS := $(DIR_STAGE)/debootstrap \
		   	   $(DIR_STAGE)/packages \
		   	   $(DIR_STAGE)/aertree \
			   $(DIR_STAGE)/csv_xs

$(DIR_STAGE)/cpd.cpd2: $(CPD_DEPENDS) $(DIR_STAGE)/.package.setup $(DIR_STAGE)/.package.tools envstrip
	-rm -f $@
	-rm -rf $(DIR)/aer/prg/cpd2	
	svn export svn+ssh://svn@aerosw/main/cpd2/trunk $(DIR)/aer/prg/cpd2
	svn info svn+ssh://svn@aerosw/main/cpd2/trunk | perl -ne 'print if s/^Revision: ([0-9]+)$$/\1/;' > $(DIR)/aer/prg/cpd2/.revision
	rsync -a --cvs-exclude /aer/prg/cpd2/etc $(DIR)/aer/prg/cpd2/
	-rm -f $(DIR)/aer/prg/cpd2/etc/cpd.conf
	$(IMGEXECNRBR) \
		$(IMGEXECNRBE) \
			LD_PRELOAD="$(DIR)/usr/lib/libgmp.so.3" \
		$(IMGEXECNRBO) \
		make -C /aer/prg/cpd2/src install $(IMGEXECNRE)
	$(IMGEXECNRB) make -C /aer/prg/cpd2/src spotless $(IMGEXECNRE)
	-rm -f $(DIR)/aer/prg/cpd2/.revision
	cp $(DIR)/aer/prg/cpd2/doc/conf.txt /aer/pub/doc/software/cpdconf.txt
	cp $(DIR)/aer/prg/cpd2/doc/conf.txt /aer/doc/ftp/software/cpdconf.txt
	touch $@

$(DIR_STAGE)/cpd.cpx2: $(CPD_DEPENDS) $(DIR_STAGE)/cpd3 $(DIR_STAGE)/cpd.cpd2 $(DIR_STAGE)/.package.setup $(DIR_STAGE)/.package.tools envstrip
	-rm -f $@
	-rm -rf $(DIR)/aer/prg/cpx2
	svn export svn+ssh://svn@aerosw/main/cpx2/trunk $(DIR)/aer/prg/cpx2
	svn info svn+ssh://svn@aerosw/main/cpx2/trunk | perl -ne 'print if s/^Revision: ([0-9]+)$$/\1/;' > $(DIR)/aer/prg/cpx2/.revision
	rsync -a --cvs-exclude /aer/prg/cpx2/etc $(DIR)/aer/prg/cpx2/
	-rm -rf $(DIR)/aer/prg/cpx2/etc/archive $(DIR)/aer/prg/cpx2/etc/tmp
	-mkdir -p $(DIR)/aer/prg/cpx2/etc/archive
	cp /aer/prg/cpx2/src/cpx2.jar /aer/prg/cpx2/src/cpx2native.h $(DIR)/aer/prg/cpx2/src/
	chmod 0664 $(DIR)/aer/prg/cpx2/src/cpx2.jar $(DIR)/aer/prg/cpx2/src/cpx2native.h
	find $(DIR)/aer/prg/cpx2/src/ -name "*.java" -exec touch \{\} \;
	touch $(DIR)/aer/prg/cpx2/src/cpx2/Version.java
	touch $(DIR)/aer/prg/cpx2/src/.bcupdated
	touch  $(DIR)/aer/prg/cpx2/src/cpx2native.h
	touch $(DIR)/aer/prg/cpx2/src/cpx2.jar
	$(IMGEXECNRBR) \
		$(IMGEXECNRBE) \
			LD_PRELOAD="$(DIR)/usr/lib/libgmp.so.3" \
		$(IMGEXECNRBO) \
		make -C /aer/prg/cpx2/src install $(IMGEXECNRE)
	$(IMGEXECNRB) make -C /aer/prg/cpx2/src clean $(IMGEXECNRE)
	$(IMGEXECNRB) /aer/prg/cpx2/doc/kb/updateindex /aer/prg/cpx2/doc/kb $(IMGEXECNRE)
	-rm -f $(DIR)/aer/prg/cpx2/.revision
	touch $@

$(DIR_STAGE)/cpd.cpd: $(CPD_DEPENDS) $(DIR_STAGE)/.package.setup $(DIR_STAGE)/.package.tools envstrip
	-rm -f $@
	-rm -rf $(DIR)/aer/prg/cpd
	rsync -a --cvs-exclude /aer/prg/cpd $(DIR)/aer/prg/
	-rm -f $(DIR)/aer/prg/cpd/cpd.ini
	-rm -rf $(DIR)/aer/prg/cpd/usr/doc $(DIR)/aer/prg/cpd/log $(DIR)/aer/prg/cpd/etc/fixes $(DIR)/aer/prg/cpd/etc/old $(DIR)/aer/prg/cpd/etc/cpdpushupdate
	-mkdir -p $(DIR)/aer/prg/cpd/usr/doc
	cp /aer/prg/cpd/usr/doc/cpdini.txt $(DIR)/aer/prg/cpd/usr/doc/
#	$(APT_SYNCIN)
#	$(IMGEXECB) aptitude --without-recommends -y install swig $(IMGEXECE)
#	$(APT_SYNCOUT)
	$(IMGEXECNRB) make -C /aer/prg/cpd/usr/src CPD=/aer/prg/cpd clean $(IMGEXECNRE)
	$(IMGEXECNRBR) \
		$(IMGEXECNRBE) \
			LD_PRELOAD="$(DIR)/usr/lib/libgmp.so.3" \
		$(IMGEXECNRBO) \
		make -C /aer/prg/cpd/usr/src CPD=/aer/prg/cpd install $(IMGEXECNRE)
#	$(IMGEXECNRBR) \
		$(IMGEXECNRBE) \
			LD_PRELOAD="$(DIR)/usr/lib/libgmp.so.3" \
		$(IMGEXECNRBO) \
		make -C /aer/prg/cpd/usr/src/cpx CPD=/aer/prg/cpd build $(IMGEXECNRE)
#	$(IMGEXECNRBR) \
		$(IMGEXECNRBE) \
			LD_PRELOAD="$(DIR)/usr/lib/libgmp.so.3" \
		$(IMGEXECNRBO) \
		make -C /aer/prg/cpd/usr/src/cpx CPD=/aer/prg/cpd install-program $(IMGEXECNRE)
	$(IMGEXECNRB) make -C /aer/prg/cpd/usr/src CPD=/aer/prg/cpd clean $(IMGEXECNRE)
#	$(IMGEXECB) aptitude -y remove swig $(IMGEXECE)
	-rm -rf $(DIR)/aer/prg/cpd/usr/src/cpx/instdata_wrap.* $(DIR)/aer/prg/cpd/usr/src/cpx/InstData.so
	touch $@

$(DIR_STAGE)/cpd: $(DIR_STAGE)/cpd.cpd2 $(DIR_STAGE)/cpd.cpd $(DIR_STAGE)/cpd.cpx2 $(CPD_DEPENDS) $(DIR_STAGE)/.package.setup $(DIR_STAGE)/.package.tools envstrip
	-rm -f $@
	touch $@

TARGETS += $(DIR_STAGE)/cpd
