FAKECHROOT_VERSION := 2.14
FAKECHROOT_FILE := fakechroot_$(FAKECHROOT_VERSION).orig.tar.gz
FAKECHROOT_URL := $(DEBIAN_MIRROR)/pool/main/f/fakechroot/$(FAKECHROOT_FILE)
FAKECHROOT_DIR := fakechroot-$(FAKECHROOT_VERSION)
FAKECHROOT_STAGING_DIR := $(DIR_BASE)/fakechroot-staging

$(DIR_STAGE)/fakechroot: $(DLLOC)/$(FAKECHROOT_FILE)
	-rm -f $@
	-rm -rf $(FAKECHROOT_STAGING_DIR) $(DIR_BASE)/$(FAKECHROOT_DIR)
	-mkdir -p $(DIR_BASE)
	( cd $(DIR_BASE) && tar xfz $(DLLOC)/$(FAKECHROOT_FILE) )
	( cd $(DIR_BASE)/$(FAKECHROOT_DIR) && cat $(LIVECPD2)/root/patches/fakechroot.*.patch | patch -p1 )
	( cd $(DIR_BASE)/$(FAKECHROOT_DIR) && ./configure \
		--prefix=/usr \
		--disable-nls \
	)
	$(MAKE) -C $(DIR_BASE)/$(FAKECHROOT_DIR)
	$(MAKE) DESTDIR=$(FAKECHROOT_STAGING_DIR) -C $(DIR_BASE)/$(FAKECHROOT_DIR) install
	-mkdir -p $(TOOLS_DIR)
	cp -a $(FAKECHROOT_STAGING_DIR)/usr/lib/fakechroot/libfakechroot*.so $(TOOLS_DIR)/
	cp -a $(FAKECHROOT_STAGING_DIR)/usr/bin/fakechroot $(TOOLS_DIR)/
	rm -rf $(FAKECHROOT_STAGING_DIR)
	sed -i \
		-e 's,^PATHS=.*,PATHS=$(TOOLS_DIR):/lib:/usr/lib,g' \
		$(TOOLS_DIR)/fakechroot
	ln -fs /dev/null $(TOOLS_DIR)/libnss_ldap.so.2
	-mkdir -p $(DIR_STAGE)
	touch $@

$(DLLOC)/$(FAKECHROOT_FILE):
	-rm -f $@
	 wget -O $@ $(FAKECHROOT_URL)


TARGETS += $(DIR_STAGE)/fakechroot
.PHONY: fakechroot
fakechroot: $(DIR_STAGE)/fakechroot
