# Not an immediate variable because the main makefile needs it
FINALIZE_FAKEROOT = $(TOOLS_DIR)/fakeroot -s $(LIVECPD2)/root/finalize.sav -i $(LIVECPD2)/root/finalize.sav --

FINALIZE_IMG_DATE := $(shell date -u '+%s %Y-%m-%dT%H:%M:%SZ')
FINALIZE_IMG_REV := $(shell svnversion)
FINALIZE_KERNEL_DATE := $(shell date -r ../kernel/bzImage -u '+%s %Y-%m-%dT%H:%M:%SZ')
FINALIZE_INITRD_DATE := $(shell date -r ../initrd/initrd.gz -u '+%s %Y-%m-%dT%H:%M:%SZ')
FINALIZE_INITRD_REV := $(shell svnversion ../initrd)

$(DIR_STAGE)/finalize: $(DIR_STAGE)/.package.ready
	-rm -f $@
	-rm -rf $(DIRF)
	-rm -f finalize.sav
	touch finalize.sav
	mkdir -p $(DIRF)
	rsync -rlptD \
		--include-from=$(DATA_DIR)/finalize.include \
		$(DIR)/* $(DIRF)/
	-rm -f $(DIRF)/usr/bin/ldd $(DIRF)/sbin/ldconfig
	mv $(DIRF)/usr/bin/ldd.REAL $(DIRF)/usr/bin/ldd
	mv $(DIRF)/sbin/ldconfig.REAL $(DIRF)/sbin/ldconfig
	-rm -f $(DIRF)/bin/imglibs
	-rm -rf $(DIRF)/lib/modules $(DIRF)/lib/firmware
	rsync -a $(LIVECPD2)/kernel/lib/* $(DIRF)/lib/
	find $(DIRF) -type l -printf "%p " -exec readlink '{}' \; | \
		egrep "^[^[:space:]]+[[:space:]]+$(DIR)/" | \
		perl -ne 'my ($$file,$$target)=split /\s+/; $$target =~ s!$(DIR)/(\S+)\s*$$!/$$1!; unlink $$file; symlink $$target, $$file;'
	$(FINALIZE_FAKEROOT) perl -ne 'chomp; my ($$dir,$$mode)=split /\s+/;	`mkdir -p $(DIRF)$$dir`; `chmod $$mode $(DIRF)$$dir`;' < $(DATA_DIR)/finalize.mkdir
	mkdir -p $(DIRF)/dev
	$(FINALIZE_FAKEROOT) perl -ne 'chomp; s/#.*$$//; s/^\s+//; next if /^$$/; my ($$mode,$$ow,$$gr,$$fn,@rest)=split /\s+/; next if @rest<1; my $$file="$(DIRF)/dev/$$fn"; system "mknod", $$file, @rest; system "chmod", $$mode, $$file; system "chown", "$$ow:$$gr", $$file;' < $(DATA_DIR)/finalize.dev
	$(FINALIZE_FAKEROOT) rsync -rlptD \
		--exclude='*.svn*' \
		$(DATA_DIR)/finalize.img/* $(DIRF)/
	$(FINALIZE_FAKEROOT) perl -ne 'chomp; s/#.*$$//; s/^\s+//; next if /^$$/; my ($$file,$$ow,$$gr,$$mode,$$flags)=split /\s+/; $$file="$(DIRF)$$file"; `chmod $$flags $$mode $$file`; `chown $$flags $$ow:$$gr $$file`' < $(DATA_DIR)/finalize.perm
	-rm -f $(DIRF)/tmp/ldsofull $(DIRF)/tmp/ldconfig
	cp $(LIVECPD2)/toolchain/usr/bin/ldconfig $(DIRF)/tmp/ldconfig
	cat `sed -ne 's!include !$(DIRF)!p' < $(DIRF)/etc/ld.so.conf` > $(DIRF)/tmp/ldsofull
	sed -e 's/include.*$$//' -e 's/#.*//' < $(DIRF)/etc/ld.so.conf >> $(DIRF)/tmp/ldsofull
	$(FINALIZE_FAKEROOT) $(DIRF)/tmp/ldconfig -r $(DIRF) -f /tmp/ldsofull
	-rm -f $(DIRF)/tmp/ldsofull $(DIRF)/tmp/ldconfig
	-rm -f $(DIRF)/aer/prg/cpd/etc/cpd.ini  $(DIRF)/aer/prg/cpd2/etc/cpd.conf
	ln -s cpd.ini.nil $(DIRF)/aer/prg/cpd/etc/cpd.ini
	ln -s cpd.nil.conf  $(DIRF)/aer/prg/cpd2/etc/cpd.conf
	-mkdir -p $(DIRF)/usr/share/livecpd2
	cp ../boot/syslinux.cfg $(DIRF)/usr/share/livecpd2/
	cp ../boot/isolinux.cfg $(DIRF)/usr/share/livecpd2/
	cp ../toolchain/boot/isolinux.bin $(DIRF)/usr/share/livecpd2/
	cp $(LIVECPD2)/toolchain/boot/ldlinux.sys $(DIRF)/usr/share/livecpd2/
	cp $(LIVECPD2)/toolchain/boot/ldlinux.bss $(DIRF)/usr/share/livecpd2/
	cp $(LIVECPD2)/bin/mkdiskimage $(DIRF)/usr/bin/
	sed -i \
		-e 's|!IMG_DATE!|$(FINALIZE_IMG_DATE)|g' \
		-e 's|!IMG_REV!|$(FINALIZE_IMG_REV)|g' \
		-e 's|!INITRD_DATE!|$(FINALIZE_INITRD_DATE)|g' \
		-e 's|!INITRD_REV!|$(FINALIZE_INITRD_REV)|g' \
		-e 's|!KERNEL_DATE!|$(FINALIZE_KERNEL_DATE)|g' \
		$(DIRF)/etc/issue
	touch $@
